$ErrorActionPreference = "Stop"

# Get user input
$ProjectName = Read-Host -Prompt "Welcome to the ArupCompute scaffolder. This script will create a new .Net Core based library for you with everything needed to host it on ArupCompute. Please enter a project name"
$TestsName = $ProjectName + "Tests"
$TopLevelDir = $PSScriptRoot
Set-Location $TopLevelDir

# Create solution
New-Item -Name $ProjectName -ItemType 'directory'
Set-Location $ProjectName
Invoke-Expression 'dotnet new sln'

# Create class library
New-Item -Name $ProjectName -ItemType 'directory'
Set-Location $ProjectName
Invoke-Expression 'dotnet new classlib'

# Create tests
Set-Location -Path '..'
New-Item -Name $TestsName -ItemType 'directory'
Set-Location $TestsName
Invoke-Expression 'dotnet new mstest'
Invoke-Expression "dotnet add reference ../$ProjectName/$ProjectName.csproj"

# Reference projects into solution
Set-Location -Path '..'
Invoke-Expression "dotnet sln add .\$ProjectName\$ProjectName.csproj"
Invoke-Expression "dotnet sln add .\$TestsName\$TestsName.csproj"

# Install credential provider
Invoke-Expression -Command "$TopLevelDir\installcredprovider.ps1"

# Add required references
Copy-Item "$TopLevelDir\nuget.config"
Set-Location $ProjectName
Invoke-Expression 'dotnet add package Arup.Compute.DotNetSdk --interactive'
Invoke-Expression 'dotnet add package Arup.Compute.Models --interactive'